/****************************************************************************
 *                                                                          *
 * Tue Jul 22 13:28:10 CEST 2014                                            *
 * Copyright or (C) or Copr. Commissariat a l'Energie Atomique              *
 *                                                                          *
 * This file is part of JCHRONOSS                                           *
 *                                                                          *
 * JCHRONOSS is free software: you can redistribute it and/or modify        *
 * it under the terms of the GNU Lesser General Public License as           *
 * published by the Free Software Foundation, either version 3 of the       *
 * License, or (at your option) any later version.                          *
 *                                                                          *
 * JCHRONOSS is distributed in the hope that it will be useful,             *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            *
 * GNU Lesser General Public License for more details.                      *
 *                                                                          *
 * You should have received a copy of the GNU Lesser General Public License *
 * along with JCHRONOSS.  If not, see <http://www.gnu.org/licenses/>.       *
 *                                                                          *
 * Version : 1.0                                                            *
 * Author  : Julien Adam <julien.adam@cea.fr>                               *
 *                                                                          *
 ***************************************************************************/

#include "HashTable.h"
using namespace std;

void HashTable::add ( int pid, Worker* nw ) {
	assert(nw != NULL);
	table.push_back(new HashItem(pid, nw));
}

Worker* HashTable::remove ( int pid ) {
	list<HashItem*>::iterator elt = find(pid);
	Worker *val = NULL;
	
	if((*elt)->pid == pid){
		val = (*elt)->work;
		delete (*elt);
		table.erase(elt);
	}
	return val;
}

list<HashTable::HashItem*>::iterator HashTable::find( int pid )
{
	list<HashItem*>::iterator cursor;
	for(cursor = table.begin(); cursor != table.end(); cursor++){
		if((*cursor)->pid == pid){
			return cursor;
		}
	}
	return table.end();
}

bool HashTable::isEmpty() const
{
	return table.empty();
}

void HashTable::stopAll()
{
	stringstream flux;
	for(list<HashItem*>::iterator it = table.begin(); it != table.end(); it++){
		flux.str("");
		flux << "\t --> Stopping " << (*it)->pid;
		printInfo(flux.str());		
		kill((*it)->pid, SIGALRM);
	}
}

