/****************************************************************************
 *                                                                          *
 * Tue Jul 22 13:28:10 CEST 2014                                            *
 * Copyright or (C) or Copr. Commissariat a l'Energie Atomique              *
 *                                                                          *
 * This file is part of JCHRONOSS                                           *
 *                                                                          *
 * JCHRONOSS is free software: you can redistribute it and/or modify        *
 * it under the terms of the GNU Lesser General Public License as           *
 * published by the Free Software Foundation, either version 3 of the       *
 * License, or (at your option) any later version.                          *
 *                                                                          *
 * JCHRONOSS is distributed in the hope that it will be useful,             *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            *
 * GNU Lesser General Public License for more details.                      *
 *                                                                          *
 * You should have received a copy of the GNU Lesser General Public License *
 * along with JCHRONOSS.  If not, see <http://www.gnu.org/licenses/>.       *
 *                                                                          *
 * Version : 1.0                                                            *
 * Author  : Julien Adam <julien.adam@cea.fr>                               *
 *                                                                          *
 ***************************************************************************/

#include "JobConstraint.h"
using namespace std;

const string JobConstraint::COMPILATION_TAG = "compilation";

JobConstraint::JobConstraint(std::string name): name(name){}

bool JobConstraint::isBelongingTo( std::string group ) const {
	if(group == "") return true;
	return name == group;
}

bool JobConstraint::operator== (const JobConstraint& other ) const {
	return(name == other.name);
}

std::string JobConstraint::getName() const {
	return (name);
}

void JobConstraint::display() const
{
	cout << " |\t\t - " << name << endl;
}
