/****************************************************************************
 *                                                                          *
 * Tue Jul 22 13:28:10 CEST 2014                                            *
 * Copyright or (C) or Copr. Commissariat a l'Energie Atomique              *
 *                                                                          *
 * This file is part of JCHRONOSS                                           *
 *                                                                          *
 * JCHRONOSS is free software: you can redistribute it and/or modify        *
 * it under the terms of the GNU Lesser General Public License as           *
 * published by the Free Software Foundation, either version 3 of the       *
 * License, or (at your option) any later version.                          *
 *                                                                          *
 * JCHRONOSS is distributed in the hope that it will be useful,             *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            *
 * GNU Lesser General Public License for more details.                      *
 *                                                                          *
 * You should have received a copy of the GNU Lesser General Public License *
 * along with JCHRONOSS.  If not, see <http://www.gnu.org/licenses/>.       *
 *                                                                          *
 * Version : 1.0                                                            *
 * Author  : Julien Adam <julien.adam@cea.fr>                               *
 *                                                                          *
 ***************************************************************************/

#include "PolicyDefault.h"
using namespace std;

DefaultPolicy::DefaultPolicy(JobManager* jobMan, Configuration* config): Policy(jobMan, config) {

}

void DefaultPolicy::fillingAlgo(Worker * cur, size_t maxIndice, size_t nbCurResources)
{
	size_t i = maxIndice;
	
	assert(maxIndice <= nbCurResources);
	UNUSED(nbCurResources);

	cur->add(jobMan->jobsLists()[i].front());
	cur->setNbRequiredResources(jobMan->jobsLists()[i].front()->getNbResources());
	jobMan->jobsLists()[i].pop_front();


}
