/****************************************************************************
 *                                                                          *
 * Tue Jul 22 13:28:10 CEST 2014                                            *
 * Copyright or (C) or Copr. Commissariat a l'Energie Atomique              *
 *                                                                          *
 * This file is part of JCHRONOSS                                           *
 *                                                                          *
 * JCHRONOSS is free software: you can redistribute it and/or modify        *
 * it under the terms of the GNU Lesser General Public License as           *
 * published by the Free Software Foundation, either version 3 of the       *
 * License, or (at your option) any later version.                          *
 *                                                                          *
 * JCHRONOSS is distributed in the hope that it will be useful,             *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            *
 * GNU Lesser General Public License for more details.                      *
 *                                                                          *
 * You should have received a copy of the GNU Lesser General Public License *
 * along with JCHRONOSS.  If not, see <http://www.gnu.org/licenses/>.       *
 *                                                                          *
 * Version : 1.0                                                            *
 * Author  : Julien Adam <julien.adam@cea.fr>                               *
 *                                                                          *
 ***************************************************************************/

#ifndef SCHEDRESPOLICY_H
#define SCHEDRESPOLICY_H

#include "Policy.h"

/// Policy implementation for the "scheduling by resources" policy
/**
 * Implements specific behaviour routines
 * In this policy, jobs are grouped by required resources criteria. A worker is 
 * started with this whole group and decrease number of launching on cluster
 * (i.e. 1 worker = N jobs identical (from resources point of view))
 * \see Policy
 */
class SchedResPolicy : public Policy
{
public:
	/************* FUNCTIONS *************/
	/// create a new "scheduling by resources" policy
	SchedResPolicy(JobManager* jobMan, Configuration* config);
	virtual void fillingAlgo(Worker* cur, size_t maxIndice, size_t nbCurResources);
};

#endif // SCHEDRESPOLICY_H
