/****************************************************************************
 *                                                                          *
 * Tue Jul 22 13:28:10 CEST 2014                                            *
 * Copyright or (C) or Copr. Commissariat a l'Energie Atomique              *
 *                                                                          *
 * This file is part of JCHRONOSS                                           *
 *                                                                          *
 * JCHRONOSS is free software: you can redistribute it and/or modify        *
 * it under the terms of the GNU Lesser General Public License as           *
 * published by the Free Software Foundation, either version 3 of the       *
 * License, or (at your option) any later version.                          *
 *                                                                          *
 * JCHRONOSS is distributed in the hope that it will be useful,             *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            *
 * GNU Lesser General Public License for more details.                      *
 *                                                                          *
 * You should have received a copy of the GNU Lesser General Public License *
 * along with JCHRONOSS.  If not, see <http://www.gnu.org/licenses/>.       *
 *                                                                          *
 * Version : 1.0                                                            *
 * Author  : Julien Adam <julien.adam@cea.fr>                               *
 *                                                                          *
 ***************************************************************************/


#include "Runner.h"

Runner::Runner() {

}
Runner::Runner ( JobManager* job, Configuration* config ) {
	
	jobMan = job;
	this->config = config;
	
	switch(config->system().getPolicy()){
		case POLICY_DEFAULT:
			policy = new DefaultPolicy(job, config);
			break;
		case POLICY_RES:
			policy = new SchedResPolicy(job, config);
			break;
		case POLICY_TIME:
			policy = new SchedTimePolicy(job, config);
			break;
		case POLICY_CUSTOM:
			policy = new CustomPolicy(job, config);
			break;
	}
}

Runner::~Runner() {
	delete policy;
}

void Runner::fillWorker ( Worker * cur, size_t nbResources ) {
	assert(cur != NULL);
	assert(nbResources > 0);
	UNUSED(cur);
	UNUSED(nbResources);
}

void Runner::launchWorker ( Worker* cur ) {
	assert(cur != NULL);
	UNUSED(cur);
}

void Runner::postActions(Worker* cur) {
	assert(cur != NULL);
	UNUSED(cur);
}

void Runner::preActions() {
}

Worker* Runner::waitNextWorker() {
	return NULL;
}

void Runner::pullJobsFromFiles()
{
	jobMan->pullJobsFromFiles();
}

void Runner::pushJobsIntoFiles()
{

}

void Runner::startCompilation()
{

}


