/****************************************************************************
 *                                                                          *
 * Tue Jul 22 13:28:10 CEST 2014                                            *
 * Copyright or (C) or Copr. Commissariat a l'Energie Atomique              *
 *                                                                          *
 * This file is part of JCHRONOSS                                           *
 *                                                                          *
 * JCHRONOSS is free software: you can redistribute it and/or modify        *
 * it under the terms of the GNU Lesser General Public License as           *
 * published by the Free Software Foundation, either version 3 of the       *
 * License, or (at your option) any later version.                          *
 *                                                                          *
 * JCHRONOSS is distributed in the hope that it will be useful,             *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            *
 * GNU Lesser General Public License for more details.                      *
 *                                                                          *
 * You should have received a copy of the GNU Lesser General Public License *
 * along with JCHRONOSS.  If not, see <http://www.gnu.org/licenses/>.       *
 *                                                                          *
 * Version : 1.0                                                            *
 * Author  : Julien Adam <julien.adam@cea.fr>                               *
 *                                                                          *
 ***************************************************************************/

#include "Dispatcher.h"
#include "XMLConfigParser.h"

using namespace std;

/******* MAIN PROGRAM ***********/
int main(int argc, char *argv[]){

	Configuration config;
	Dispatcher bigBoss(&config);
	
	config.parseOptions(argc, argv);
	bigBoss.setRunner();
	
	if(config.isMaster())
		config.printConfiguration();
	
	//set with autokill in config
	if(config.system().getAutokill() > SystemConfiguration::DEFAULT_AUTOKILL)
		alarm(config.system().getAutokill());

	bigBoss.startScheduling();

	return 0;
}

